-- program to test some of the button functionality
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk    (GtkWindowType(..),
               GtkObjectSignalHandler(..), gtkObjectSignalConnect,
	       GtkBox, gtkBoxPackStart,
	       GtkHBox, gtkHBoxNew,
	       GtkVBox, gtkVBoxNew,
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       gtkButtonSignalConnectObject,  
	       GtkCheckButton, gtkCheckButtonNewWithLabel,
	       GtkContainer, gtkContainerBorderWidth, gtkContainerAdd,
	       GtkToggleButton, gtkToggleButtonNewWithLabel,
	       gtkToggleButtonSetMode, gtkToggleButtonQueryState,
	       GtkWidget, gtkWidgetShow, gtkWidgetDestroy,
	       GtkWidgetSignalHandler(..), gtkWidgetSignalConnect,
	       GtkWindow, gtkWindowNew, gtkWindowSetTitle,
	       gtkInit, gtkMain, gtkMainQuit)

delete :: GtkToggleButton -> GtkCheckButton -> IO ()
delete togBtn checkBtn = 
  do
    active <- gtkToggleButtonQueryState togBtn
    putStr ("Toggle button: " ++ (if active then "on" else "off") ++ "\n")
    checked <- gtkToggleButtonQueryState checkBtn
    putStr ("Check button: " ++ (if checked then "on" else "off") ++ "\n")
    gtkMainQuit

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "Test Buttons..."
	  gtkContainerBorderWidth window 10

	  -- box for the whole thing
	  --
	  bigBox <- gtkVBoxNew False 10
	  gtkContainerAdd window bigBox

	  checkBtn <- gtkCheckButtonNewWithLabel " Check me out! "
	  gtkContainerAdd bigBox checkBtn
	  gtkWidgetShow checkBtn

	  -- box for assembling buttons
	  --
	  butBox <- gtkHBoxNew False 10
	  gtkContainerAdd bigBox butBox

	  togBtn <- gtkToggleButtonNewWithLabel " On/Off "
	  gtkBoxPackStart butBox togBtn True True 0
--	  gtkToggleButtonSetMode togBtn True
	  gtkWidgetShow togBtn

	  buttonQuit <- gtkButtonNewWithLabel " Quit "
	  let quitHandler wd = delete togBtn checkBtn
	  gtkButtonSignalConnectObject 
	    buttonQuit (GtkButtonClickedHandler quitHandler) window
	  gtkBoxPackStart butBox buttonQuit True True 0
	  gtkWidgetShow buttonQuit

	  -- can't be near the alloc of `window', because we need the buttons
	  --
	  gtkWidgetSignalConnect 
	    window (GtkWidgetDeleteEventHandler (\_ _ -> do
							   delete togBtn checkBtn
							   return False))
	  gtkWidgetShow butBox
	  gtkWidgetShow bigBox
	  gtkWidgetShow window

	  gtkMain

	  exitWith ExitSuccess
