-- A simple program to test Gdk drawing routines
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gdk
import Gtk

exposureHandler    :: GtkDrawingArea -> IO Bool
exposureHandler da  =
  do
    style <- gtkWidgetGetStyle da
    state <- gtkWidgetGetState da
    gc    <- gtkStyleGetFgGC style state
    drawable <- gtkWidgetGetWindow da
    gdkDrawLine drawable gc 0 0 100 100
    gdkDrawRectangle drawable gc True 50 0 100 50 
    return False

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "GTK+ Drawing Area Test"
	  gtkWidgetSetUSize window 200 100
	  let winDelHdl = GtkWidgetDeleteEventHandler $ \_ _ -> do
								   gtkMainQuit
								   return False
	  gtkWidgetSignalConnect window winDelHdl
	  gtkContainerBorderWidth window 10

          drawArea <- gtkDrawingAreaNew
	  let exposureHdl = GtkWidgetExposeEventHandler $ \da _ -> do
			      exposureHandler da
          gtkWidgetSignalConnect drawArea exposureHdl
          gtkContainerAdd window drawArea
          gtkWidgetShow drawArea

	  gtkWidgetShow window

	  gtkMain
	  exitWith ExitSuccess
