-- simple radio button dialog
--

import System (getArgs, ExitCode(ExitSuccess, ExitFailure), exitWith)
import Monad  (when)
import Gtk    (GtkWindowType(..),
               GtkObjectSignalHandler(..), gtkObjectSignalConnect,
	       GtkBox, gtkBoxPackStartDefaults,
	       GtkHBox, gtkHBoxNew,
	       GtkVBox, gtkVBoxNew,
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       gtkButtonSignalConnectObject,  
	       GtkContainer, gtkContainerBorderWidth, gtkContainerAdd,
	       GtkEditableSignalHandler(..), gtkEditableSignalConnect,
	       GtkEntry, gtkEntryGetText, gtkEntrySetVisibility, 
	       gtkEntrySetEditable, gtkEntryNewWithMaxLength, gtkEntrySetText,
	       gtkEntryAppendText, gtkEntrySelectRegion,
	       GtkFileSelection, gtkFileSelectionNew,
	       gtkFileSelectionGetFilename, gtkFileSelectionShowFileopButtons,
	       gtkFileSelectionQueryButtons, gtkFileSelectionSetFilename,
	       GtkLabel, gtkLabelNew,
	       GtkRadioButton, gtkRadioButtonNewWithLabel,
	       gtkRadioButtonNewWithLabelFromWidget, 
	       GtkWidget, gtkWidgetShow, gtkWidgetDestroy,
	       GtkWidgetSignalHandler(..), gtkWidgetSignalConnect,
	       GtkWindow, gtkWindowNew, gtkWindowSetTitle,
	       gtkWindowSetDefaultSize, 
	       gtkInit, gtkMain, gtkMainQuit)


main :: IO ()
main  = do
          preArgs <- getArgs
	  args <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "To be or not to be..."
	  gtkWindowSetDefaultSize window 350 130
	  let winDelHdl = GtkWidgetDeleteEventHandler $ \_ _ -> do
								   gtkMainQuit
								   return False
	  gtkWidgetSignalConnect window winDelHdl
	  gtkContainerBorderWidth window 10

	  -- box for the whole thing
	  --
	  bigBox <- gtkVBoxNew False 10
	  gtkContainerAdd window bigBox
	  gtkWidgetShow bigBox

	  -- box for the radio buttons
	  --
	  rbutBox <- gtkVBoxNew False 0
	  gtkContainerAdd bigBox rbutBox
	  gtkWidgetShow rbutBox

	  -- the radio buttons
	  --
	  lbl <- gtkLabelNew "Does Haskell support GUIs?"
	  gtkContainerAdd rbutBox lbl
	  gtkWidgetShow lbl
	  rb1 <- gtkRadioButtonNewWithLabel "Yes, of course!"
	  gtkContainerAdd rbutBox rb1
	  gtkWidgetShow rb1
	  rb2 <- gtkRadioButtonNewWithLabelFromWidget rb1 
		   "Real functional programmers use text-based I/O."
	  gtkContainerAdd rbutBox rb2
	  gtkWidgetShow rb2
	  rb3 <- gtkRadioButtonNewWithLabelFromWidget rb2 "What's a GUI?"
	  gtkContainerAdd rbutBox rb3
	  gtkWidgetShow rb3

	  buttonQuit <- gtkButtonNewWithLabel " Quit "
	  let quitHandler wd = gtkWidgetDestroy wd >> gtkMainQuit
	  gtkButtonSignalConnectObject 
	    buttonQuit (GtkButtonClickedHandler quitHandler) window
	  gtkBoxPackStartDefaults bigBox buttonQuit
	  gtkWidgetShow buttonQuit

	  gtkWidgetShow window

	  gtkMain
	  exitWith ExitSuccess
