-- The enhanced & robust infamous `Hello World!' program using the GTK binding
-- for Haskell 
--
--    ghc -o hello3 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld3.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess))
import Gtk    (GtkWindowType(..),
               GtkObjectSignalHandler(..), gtkObjectSignalConnect,
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       gtkButtonSignalConnectObject,  
	       GtkContainer, gtkContainerSetBorderWidth, gtkContainerAdd,
	       GtkWidget, gtkWidgetShow, gtkWidgetDestroy,
	       GtkWindow, gtkWindowNew,
	       gtkInit, gtkMain, gtkExit)

hello :: IO ()
hello  = do
	   putStr "Hello World!\n"
	   gtkExit ExitSuccess

destroy :: IO ()
destroy  = gtkExit ExitSuccess

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkObjectSignalConnect window 
				 (GtkObjectDestroyHandler (const destroy))
	  gtkContainerSetBorderWidth window 10

	  button <- gtkButtonNewWithLabel "Hello World!"
	  gtkButtonSignalConnect button (GtkButtonClickedHandler (const hello))
	  gtkButtonSignalConnectObject 
	    button (GtkButtonClickedHandler gtkWidgetDestroy) window
	  gtkContainerAdd window button
	  gtkWidgetShow button

	  gtkWidgetShow window

	  gtkMain
