-- The upgraded enhanced & robust infamous `Hello World!' program using the
-- GTK binding for Haskell 
--
--    ghc -o hello4 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld4.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk    (GtkWindowType(..),
               GtkObjectSignalHandler(..), gtkObjectSignalConnect,
	       GtkBox, gtkBoxPackStart,
	       GtkHBox, gtkHBoxNew,
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       gtkButtonSignalConnectObject,  
	       GtkContainer, gtkContainerBorderWidth, gtkContainerAdd,
	       GtkWidget, gtkWidgetShow, gtkWidgetDestroy,
	       GtkWidgetSignalHandler(..), gtkWidgetSignalConnect,
	       GtkWindow, gtkWindowNew, gtkWindowSetTitle,
	       gtkInit, gtkMain, gtkMainQuit)

hello     :: String -> IO ()
hello str  = putStr ("Hello again! - " ++ str ++ " was pressed\n")

delete :: IO Bool
delete  = do
	    gtkMainQuit
	    return False

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "Hello Buttons!"
	  gtkWidgetSignalConnect window 
				 (GtkWidgetDeleteEventHandler (\_ _ -> delete))
	  gtkContainerBorderWidth window 10

	  -- box for assembling buttons
	  --
	  box <- gtkHBoxNew False 0
	  gtkContainerAdd window box

	  button1 <- gtkButtonNewWithLabel "Button 1"
	  let handler1 = const (hello "button 1")
	  gtkButtonSignalConnect button1 (GtkButtonClickedHandler handler1)
	  gtkBoxPackStart box button1 True True 0
	  gtkWidgetShow button1

	  button2 <- gtkButtonNewWithLabel "Button 2"
	  let handler1 = const (hello "button 2")
	  gtkButtonSignalConnect button2 (GtkButtonClickedHandler handler1)
	  gtkBoxPackStart box button2 True True 0
	  gtkWidgetShow button2

	  gtkWidgetShow box
	  gtkWidgetShow window

	  gtkMain
	  exitWith ExitSuccess
