-- The upgraded enhanced & even more robust infamous `Hello World!' program
-- using the GTK binding for Haskell 
--
--    ghc -o hello5 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld5.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk    (GtkWindowType(..),
               GtkObjectSignalHandler(..), gtkObjectSignalConnect,
	       GtkBox, gtkBoxPackStart,
	       GtkHBox, gtkHBoxNew,
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       gtkButtonSignalConnectObject,  
	       GtkContainer, gtkContainerBorderWidth, gtkContainerAdd,
	       GtkWidget, gtkWidgetShow, gtkWidgetDestroy,
	       GtkWidgetSignalHandler(..), gtkWidgetSignalConnect,
	       GtkWindow, gtkWindowNew, gtkWindowSetTitle,
	       gtkInit, gtkMain, gtkMainQuit)

hello     :: String -> IO ()
hello str  = putStr ("Hello again! - " ++ str ++ " was pressed\n")

delete :: IO Bool
delete  = do
	    gtkMainQuit
	    return False	-- `False' means, window may be removed

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "Hello Buttons!"
	  gtkWidgetSignalConnect window 
				 (GtkWidgetDeleteEventHandler (\_ _ -> delete))
	  gtkContainerBorderWidth window 10

	  -- box for assembling buttons
	  --
	  box <- gtkHBoxNew False 10
	  gtkContainerAdd window box

	  button1 <- gtkButtonNewWithLabel "Button 1"
	  let handler1 = const (hello "button 1")
	  gtkButtonSignalConnect button1 (GtkButtonClickedHandler handler1)
	  gtkBoxPackStart box button1 True True 0
	  gtkWidgetShow button1

	  button2 <- gtkButtonNewWithLabel "Button 2"
	  let handler1 = const (hello "button 2")
	  gtkButtonSignalConnect button2 (GtkButtonClickedHandler handler1)
	  gtkBoxPackStart box button2 True True 0
	  gtkWidgetShow button2

	  buttonQuit <- gtkButtonNewWithLabel "Quit"
	  let quitHandler wd = gtkWidgetDestroy wd >> gtkMainQuit
	  gtkButtonSignalConnectObject 
	    buttonQuit (GtkButtonClickedHandler quitHandler) window
	  gtkBoxPackStart box buttonQuit True True 0
	  gtkWidgetShow buttonQuit

	  gtkWidgetShow box
	  gtkWidgetShow window

	  gtkMain
	  exitWith ExitSuccess
