-- test idle and timeout handlers

import System     (getArgs, ExitCode(ExitSuccess, ExitFailure), exitWith)

import IOExts

import Gtk        

-- idle handler 
--
idleHandler         :: GtkLabel -> IORef Int ->  IO Bool
idleHandler lbl var  = do
		         num <- readIORef var
			 writeIORef var (num + 1)
			 gtkLabelSet lbl ("Label #" ++ show num)
			 return True

-- show the current number when a timeout occurs
--
timeout     :: IORef Int -> IO Bool
timeout var  = do
                 num <- readIORef var
                 putStrLn ("The current number is " ++ show num)
                 return True

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "GTK+ Idle & Timeout Test"
	  gtkWindowSetDefaultSize window 180 90
	  let winDelHdl = GtkWidgetDeleteEventHandler $ \_ _ -> do
								   gtkMainQuit
								   return False
	  gtkWidgetSignalConnect window winDelHdl
	  gtkContainerBorderWidth window 10

	  label <- gtkLabelNew "Initial label"
	  gtkContainerAdd window label

          var <- newIORef (0 :: Int)
          gtkIdleAdd (GtkIdleHandler $ idleHandler label var)
          gtkTimeoutAdd 500 (GtkTimeoutHandler $ timeout var)

	  gtkWidgetShowAll window
	  gtkMain
	  exitWith ExitSuccess
