-- test label and frame widgets

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk

delete :: IO Bool
delete  = do
	    gtkMainQuit
	    return False

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "Label & Frame"
	  gtkWidgetSignalConnect window 
				 (GtkWidgetDeleteEventHandler (\_ _ -> delete))
	  gtkContainerBorderWidth window 10

	  frame <- gtkFrameNew "Frame Label"
	  gtkFrameSetShadowType frame GtkShadowEtchedOut
	  gtkContainerAdd window frame

	  label <- gtkLabelNew "This is the text of a label that is set \
			       \line-wrapped and filled, and thus, it can \
			       \nicely display a lot of text.\n\
			       \     It is so smart that it even knows about \
			       \paragraphs and proves that GTK+ is a very \
			       \cool toolkit, indeed."
          gtkLabelSetLineWrap label True
	  gtkLabelSetJustify label GtkJustifyFill
	  gtkContainerAdd frame label

	  gtkWidgetShowAll window

	  gtkMain
	  exitWith ExitSuccess
