-- program to test the table widget (adapted from GTK+/Gnome book)
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk    (GtkWindowType(..), GtkAttachOptions(..),
               GtkObjectSignalHandler(..), gtkObjectSignalConnect,
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       gtkButtonSignalConnectObject,  
	       GtkContainer, gtkContainerSetBorderWidth, gtkContainerAdd,
	       GtkTable, gtkTableNew, gtkTableAttach,
	       GtkWidget, gtkWidgetShowAll, gtkWidgetDestroy,
	       GtkWidgetSignalHandler(..), gtkWidgetSignalConnect,
	       GtkWindow, gtkWindowNew, gtkWindowSetTitle, gtkWindowSetPolicy,
	       gtkInit, gtkMain, gtkMainQuit)

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkWindowSetTitle window "Test Table..."
	  gtkWidgetSignalConnect 
	    window (GtkWidgetDeleteEventHandler (\_ _ -> do 
							   gtkMainQuit
							   return False))

	  -- create table container
	  --
	  table <- gtkTableNew 2 2 False
	  gtkContainerAdd window table
	  gtkContainerSetBorderWidth table 10

	  -- the following is to experiment with resizing, but usually a bad
	  -- idea in real code
	  --
	  gtkWindowSetPolicy window True True True

	  button <- gtkButtonNewWithLabel "1. Doesn't shrink\nor expand"
	  gtkTableAttach table button 0 1 0 1 [GtkFill] [GtkFill] 0 0

	  button <- gtkButtonNewWithLabel "2. Expands and shrinks\n\
					  \vertically"
	  gtkTableAttach table button 0 1 1 2 
	    [GtkFill] [GtkFill, GtkExpand, GtkShrink] 0 0

	  button <- gtkButtonNewWithLabel "3. Expands and shrinks\n\
					  \in both directions"
	  gtkTableAttach table button 1 2 0 2 
	    [GtkFill, GtkExpand, GtkShrink] [GtkFill, GtkExpand, GtkShrink] 0 0

	  gtkWidgetShowAll window
	  gtkMain
	  exitWith ExitSuccess
